/*#########################################################################
#                                                                         #
#   Copyright     							  #
#									  #
#   (C)  2009 Àlvar Cuevas i Fajardo <alvar@cuevas.cat>                   #
#   (C)  2008 Eirik Johansen Bjørgan  <eirikjbj@gmail.com> 		  #
#   (C) 2007, 2008 Nikolaj Hald Nielsen  <nhnFreespirit@gmail.com>        #
#   (C)       2008 Peter ZHOU <peterzhoulei@gmail.com>                    #
#   (C)       2008 Mark Kretschmann <kretschmann@kde.org>                 #
#                                                                         #
#   This program is free software; you can redistribute it and/or modify  #
#   it under the terms of the GNU General Public License as published by  #
#   the Free Software Foundation; either version 2 of the License, or     #
#   (at your option) any later version.                                   #
#                                                                         #
#   This program is distributed in the hope that it will be useful,       #
#   but WITHOUT ANY WARRANTY; without even the implied warranty of        #
#   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         #
#   GNU General Public License for more details.                          #
#                                                                         #
#   You should have received a copy of the GNU General Public License     #
#   along with this program; if not, write to the                         #
#   Free Software Foundation, Inc.,                                       #
#   51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.         #
##########################################################################*/

Importer.loadQtBinding("qt.core");
Importer.loadQtBinding("qt.gui");

function Station( name, url, description )
{
    this.name = name;
    this.url = url;
    this.description = description;
}


categories = new Object;

categories["IB3 Ràdio"]=new Array (
    new Station("IB3 Ràdio", "mms://194.179.36.187/IB3Radio", "IB3 Ràdio")
);

categories["CCL Ràdio"]=new Array (
    new Station("COMRàdio", "http://213.27.152.121:8000/comradio", "COMRàdio")
);

categories["RTVV Ràdio"]= new Array (
    new Station( "Ràdio Nou València", "mms://cache.gva.es/radio9v1?radionou", "Ràdio Nou València" ),
    new Station( "Ràdio Nou Castelló", "mms://cache.gva.es/radio9c1?radionou", "Ràdio Nou Castelló" ),
    new Station( "Ràdio Nou Alacant", "mms://cache.gva.es/radio9a1?radionou", "Ràdio Nou Alacant" ),
    new Station( "Sí Ràdio", "mms://cache.gva.es/siradio1?radionou", "Sí Ràdio" )
);

categories["CCMA Ràdio"]= new Array (
    new Station( "Catalunya Ràdio", "mms://catradio.directe-wm.emissio.catradio.cat/reflector:37163?origin=extern", "Catalunya Ràdio" ),
    new Station( "Catalunya Informació", "mms://catinfo.directe-wm.emissio.catradio.cat/reflector:37254?origin=extern", "Catalunya Informació" ),
    new Station( "Catalunya Música", "mms://catmusica.directe-wm.emissio.catradio.cat/reflector:36524?origin=extern", "Catalunya Música" ),
    new Station( "CatClàssica", "mms://catclassica.directe-wm.emissio.catradio.cat/reflector:22521?origin=extern", "CatClàssica" ),
    new Station( "iCATfm", "mms://icatfm.directe-wm.emissio.catradio.cat/reflector:35490?origin=extern", "iCATfm" ),
    new Station( "iCATjazz", "mms://icatjazz.directe-wm.emissio.catradio.cat/reflector:34439?origin=extern", "iCATjazz" ),
    new Station( "musiCATles", "mms://musicatles.directe-wm.emissio.catradio.cat/reflector:24901?origin=extern", "musiCATles" ),
    new Station( "totCAT", "mms://totcat.directe-wm.emissio.catradio.cat/reflector:37088?origin=extern", "totCAT" ),
    new Station( "mediterRadio", "mms://catmediterradio.directe-wm.emissio.catradio.cat/reflector:59057", "mediterRadio" ),
    new Station( "Xahrazad", "mms://xahrazad.directe-wm.emissio.catradio.cat/reflector:52815", "Xahrazad" )
);

categories["RTVE Ràdio"]=new Array (
    new Station( "Ràdio 4", "mms://a783.l1041530780.c10415.e.lm.akamaistream.net/D/783/10415/v0001/reflector:30780", "Ràdio 4" )
);

categories["Federació de Ràdios Locals de Catalunya"]=new Array (
    new Station( "L'Espluga FM Ràdio", "http://esplugafmradio.no-ip.info:8000", "L'Espluga FM Ràdio" ),
    new Station( "La Plana Ràdio", "http://80.32.249.15:8000/", "La Plana Ràdio" ),
    new Station( "Punt 6 Ràdio", "http://www.punt6radio.cat:8500/", "Punt 6 Ràdio" ),
    new Station( "Ràdio Argentona", "http://argcom.gnuine.com:8000/argentona", "Ràdio Argentona" ),
    new Station( "Ràdio Canet", "http://verdi.serveisweb.com/rp005", "Ràdio Canet" ),
    new Station( "Ràdio Castellar", "http://verdi.serveisweb.com/RC015", "Ràdio Castellar" ),
    new Station( "Ràdio El Vendrell", "mms://albeniz.serveisweb.com/RE021", "Ràdio El Vendrell" ),
    new Station( "Ràdio Flix", "http://91.121.2.97:8020", "Ràdio Flix" ),
    new Station( "Ràdio Igualada", "http://82.159.204.89:8040/live884", "Ràdio Igualada" ),
    new Station( "Ràdio Hospitalet de l'Infant", "mms://217.76.128.22/vandellos-hospitalet.org.radiohospitalet", "Ràdio Hospitalet de l'Infant" ),
    new Station( "Ràdio Litoral", "http://80.34.235.166:8000", "Ràdio Litoral" ),
    new Station( "Ràdio Mollet", "http://bach.serveisweb.com/RA171", "Ràdio Mollet" ),
    new Station( "Ràdio Palafolls", "http://80.59.136.237:8000/rp.ogg", "Ràdio Palafolls" ),
    new Station( "Ràdio Sabadell", "mms://stream.mersisl.net/RadioSabadellDirecto", "Ràdio Sabadell" ),
    new Station( "Ràdio Sant Cugat", "http://directe.cugat.cat/directeHQ.mp3", "Ràdio Sant Cugat" ),
    new Station( "Ràdio Sant Feliu", "http://62.193.192.91:8004", "Ràdio Sant Feliu" ),
    new Station( "Ràdio Sant Hilari", "http://verdi.serveisweb.com/RS006", "Ràdio Sant Hilari" ),
    new Station( "Ràdio Sió", "http://80.59.113.123:8000/", "Ràdio Sió" ),
    new Station( "Ràdio Tàrrega", "http://213.97.31.94:8000/", "Ràdio Tàrrega" ),
    new Station( "Ràdio Trinitat Vella", "http://www.radioendirecto.net:8008", "Ràdio Trinitat Vella" ),
    new Station( "Ràdio Vilafant", "http://217.125.100.168:8000/icy_0", "Ràdio Vilafant" ),
    new Station( "Rap 107.2 FM", "http://www.rap107.fm:18100/", "Rap 107.2 FM" )
);

categories["z) Emissores privades"]=new Array (
    new Station( "Ràdio Flaixbac","http://195.10.10.104:80/flaix/flaixbac.mp3","Ràdio Flaixbac"),
    new Station( "Flaix FM","http://195.10.10.103:80/flaix/FLAIXfm.mp3","Flaix FM"),
    new Station( "RAC 1","http://212.48.125.96:80","RAC 1"),
    new Station( "Ona FM","http://80.231.170.146:8052/live881ser","Ona FM"),
    new Station( "RAC 105","http://212.48.125.98:80/","RAC 105"),
    new Station( "Ràdio Arrels","http://213.186.61.62:7100/","Ràdio Arrels"),
    new Station( "TotRàdio","http://www.totradio.com:8000/128kbps","TotRàdio")
);

images = new Object;
images["IB3 Ràdio"]="ib3.png";
images["CCL Ràdio"]="ccl.png";
images["CCMA Ràdio"]="ccma.png";
images["RTVE Ràdio"]="rtve.png";
images["RTVV Ràdio"]="rtvv.png";
images["Federació de Ràdios Locals de Catalunya"]="frlc.png";
images["z) Emissores privades"]="icon.png";

function CATradio()
{
    ScriptableServiceScript.call( this, "CAT Ràdio", 2, "Llistat d'emisores públiques de ràdio en català", "Emisions en directe de ràdio en català", false );
    Amarok.debug( "ok." );
}

function onConfigure()
{
    Amarok.alert( "No cal configuració per aquest script." );
}

function onPopulating( level, callbackData, filter )
{
    if ( level == 1 ) 
    {
        for( att in categories )
        {
            var cover = Amarok.Info.scriptPath() + "/" + images[att];
            Amarok.debug ("att: " + att + ", " + categories[att].name);
      
            item = Amarok.StreamItem;
	    item.level = 1;
	    item.callbackData = att;
	    item.itemName = att;
	    item.playableUrl = "";
	    item.infoHtml = "";
            item.coverUrl = cover;
	    script.insertItem( item );

        }
        script.donePopulating();

    }
    else if ( level == 0 ) 
    {
        Amarok.debug( " Recopilant emisores..." );
	//add the station streams as leaf nodes

        var stationArray = categories[callbackData];

	for ( i = 0; i < stationArray.length; i++ )
	{
                var cover = Amarok.Info.scriptPath() + "/" + images[callbackData];
		item = Amarok.StreamItem;
		item.level = 0;
		item.callbackData = "";
		item.itemName = stationArray[i].name;
		item.playableUrl = stationArray[i].url;
		item.album = callbackData;
		item.infoHtml = stationArray[i].description;
                item.artist = "Fluix de ràdio";
                item.coverUrl = cover;
		script.insertItem( item );
	}
	script.donePopulating();
    }
}

function onCustomize() {
    var currentDir = Amarok.Info.scriptPath() + "/";
    var iconPixmap = new QPixmap(currentDir+"icon.png");
    script.setIcon(iconPixmap);
}

Amarok.configured.connect( onConfigure );

script = new CATradio();
script.populate.connect( onPopulating );
script.customize.connect( onCustomize );
